// 003 u_c_http_raw_log_pages
// 24 dec 2001

// -- (C) John COLIBRI 2001
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_http_raw_log_pages;
  interface
    uses Classes, u_c_basic_object;

    type c_http_raw_log_pages= Class;

         c_http_raw_log_page= // one "http_raw_log_page"
                              Class(c_basic_object)
                                public
                                  m_c_http_raw_log_page_list: c_http_raw_log_pages;
                                  m_http_raw_log_page_name: String;
                                  m_http_raw_log_page_count: Integer;
                                  m_elapsed_time: Integer;
                                  m_used: Boolean;

                                  Constructor create_http_raw_log_page(p_name, p_http_raw_log_page_name: String;
                                      p_c_http_raw_log_pages: c_http_raw_log_pages; p_elapsed_time: Integer); Virtual;
                                  function f_display_http_raw_log_page: String;
                                  Destructor Destroy; Override;
                              end;

         c_http_raw_log_pages= // "http_raw_log_page" list
                               Class(c_basic_object)
                                 public
                                   m_c_http_raw_log_page_list: tStringList;
                                   m_max_http_raw_log_page_length: Integer;

                                   Constructor create_http_raw_log_pages(p_name: String); Virtual;

                                   function f_http_raw_log_page_count: Integer;
                                   function f_c_http_raw_log_page(p_http_raw_log_page: Integer): c_http_raw_log_page;
                                   procedure add_http_raw_log_page(p_c_http_raw_log_page: c_http_raw_log_page);
                                   procedure add_or_increment(p_http_raw_log_page_name: String; p_elapsed_time: Integer);

                                   procedure display_http_raw_log_pages;
                                   procedure display_zip_ppt;
                                   procedure display_non_zip_ppt_http_raw_log_pages;

                                   procedure display_indented_zip_and_ppt(p_site_map_name: String);
                                   procedure display_indented_html(p_site_map_name: String);
                                   procedure display_unused;

                                   Destructor Destroy; Override;
                               end;

  implementation
    uses SysUtils, u_strings, u_strings_html
        , u_c_display;

    // -- c_http_raw_log_page

    Constructor c_http_raw_log_page.create_http_raw_log_page(p_name, p_http_raw_log_page_name: String;
        p_c_http_raw_log_pages: c_http_raw_log_pages; p_elapsed_time: Integer);
      begin
        Inherited create_basic_object(p_name);
        m_http_raw_log_page_name:= p_http_raw_log_page_name;
        m_c_http_raw_log_page_list:= p_c_http_raw_log_pages;

        m_http_raw_log_page_count:= 1;
        m_elapsed_time:= p_elapsed_time;
      end; // create_http_raw_log_page

    function c_http_raw_log_page.f_display_http_raw_log_page: String;
      begin
        Result:= Format('%-'+ IntToStr(m_c_http_raw_log_page_list.m_max_http_raw_log_page_length)+ 's %3d ', [m_http_raw_log_page_name, m_http_raw_log_page_count]);
      end; // f_display_http_raw_log_page

    Destructor c_http_raw_log_page.Destroy;
      begin
        InHerited;
      end; // Destroy

    // -- c_http_raw_log_pages

    Constructor c_http_raw_log_pages.create_http_raw_log_pages(p_name: String);
      begin
        Inherited create_basic_object(p_name);

        m_c_http_raw_log_page_list:= tStringList.Create;
      end; // create_http_raw_log_page_line

    function c_http_raw_log_pages.f_http_raw_log_page_count: Integer;
      begin
        Result:= m_c_http_raw_log_page_list.Count;
      end; // f_http_raw_log_page_count

    function c_http_raw_log_pages.f_c_http_raw_log_page(p_http_raw_log_page: Integer): c_http_raw_log_page;
      begin
        Result:= c_http_raw_log_page(m_c_http_raw_log_page_list.Objects[p_http_raw_log_page]);
      end; //  f_c_http_raw_log_page

    procedure c_http_raw_log_pages.add_http_raw_log_page(p_c_http_raw_log_page: c_http_raw_log_page);
      var l_length: Integer;
      begin
        if Pos('404', p_c_http_raw_log_page.m_http_raw_log_page_name)<= 0
          then begin
              l_length:= Length(p_c_http_raw_log_page.m_http_raw_log_page_name);
              if l_length> m_max_http_raw_log_page_length
                then m_max_http_raw_log_page_length:= l_length;
            end;    

        m_c_http_raw_log_page_list.AddObject(p_c_http_raw_log_page.m_http_raw_log_page_name, tObject(p_c_http_raw_log_page));
      end; // add_http_raw_log_page

    procedure c_http_raw_log_pages.add_or_increment(p_http_raw_log_page_name: String; p_elapsed_time: Integer);
      var l_index: Integer;
      begin
        l_index:= m_c_http_raw_log_page_list.IndexOf(p_http_raw_log_page_name);
        if l_index< 0
          then add_http_raw_log_page(c_http_raw_log_page.create_http_raw_log_page('http_raw_log_page', p_http_raw_log_page_name, Self, p_elapsed_time))
          else
            with f_c_http_raw_log_page(l_index) do
            begin
              Inc(m_http_raw_log_page_count);
              Inc(m_elapsed_time, p_elapsed_time);
            end;
      end; // add_or_increment

    procedure c_http_raw_log_pages.display_http_raw_log_pages;
      var l_http_raw_log_page: Integer;
      begin
        for l_http_raw_log_page:= 0 to f_http_raw_log_page_count- 1 do
          display(f_c_http_raw_log_page(l_http_raw_log_page).f_display_http_raw_log_page);
      end; // display_http_raw_log_pages

    procedure c_http_raw_log_pages.display_zip_ppt;
      var l_http_raw_log_page_name: String;
          l_http_raw_log_page: Integer;
      begin
        display_line;
        for l_http_raw_log_page:= 0 to f_http_raw_log_page_count- 1 do
        begin
          l_http_raw_log_page_name:= f_c_http_raw_log_page(l_http_raw_log_page).m_http_raw_log_page_name;
          if f_end_is_equal_to(l_http_raw_log_page_name, '.zip') or f_end_is_equal_to(l_http_raw_log_page_name, '.ppt')
            then display(f_c_http_raw_log_page(l_http_raw_log_page).f_display_http_raw_log_page);
          // display(f_c_http_raw_log_page(l_http_raw_log_page).f_display_http_raw_log_page);
        end;
      end; // display_zip_ppt

    procedure c_http_raw_log_pages.display_non_zip_ppt_http_raw_log_pages;
      begin
      end; // display_non_zip_ppt_http_raw_log_pages

    procedure c_http_raw_log_pages.display_indented_zip_and_ppt(p_site_map_name: String);
      const k_name_columns= 35;
      var l_total_zip: Integer;

      procedure display_log(p_map_name: String);
        var l_http_raw_log_page_name: String;
            l_http_raw_log_page: Integer;
            l_map_name: String;
            l_text: String;
        begin
          l_map_name:= Trim(p_map_name);

          l_text:= '';
          // -- first the zip
          for l_http_raw_log_page:= 0 to f_http_raw_log_page_count- 1 do
          begin
            l_http_raw_log_page_name:= f_c_http_raw_log_page(l_http_raw_log_page).m_http_raw_log_page_name;
            if f_end_is_equal_to(l_http_raw_log_page_name, '.zip') and (l_map_name+ '.zip'= l_http_raw_log_page_name)
              then begin
                  l_text:= Format('%2d ', [f_c_http_raw_log_page(l_http_raw_log_page).m_http_raw_log_page_count]);
                  Inc(l_total_zip, f_c_http_raw_log_page(l_http_raw_log_page).m_http_raw_log_page_count);

                  f_c_http_raw_log_page(l_http_raw_log_page).m_used:= True;
                end;
          end;

          // -- then the ppt
          for l_http_raw_log_page:= 0 to f_http_raw_log_page_count- 1 do
          begin
            l_http_raw_log_page_name:= f_c_http_raw_log_page(l_http_raw_log_page).m_http_raw_log_page_name;
            if f_end_is_equal_to(l_http_raw_log_page_name, '.ppt') and (l_map_name+ '.ppt'= l_http_raw_log_page_name)
              then begin
                  l_text:= l_text+ Format(' %2d ', [f_c_http_raw_log_page(l_http_raw_log_page).m_http_raw_log_page_count]);
                  f_c_http_raw_log_page(l_http_raw_log_page).m_used:= True;
                end;
          end;

          if l_text<> ''
            then display(Format('%-'+ IntToStr(k_name_columns)+ 's ', [p_map_name])+ l_text);
        end; // display_log

      var l_c_site_map: tStringList;
          l_index: Integer;
          l_name: String;

      begin // display_indented_zip_and_ppt
        l_c_site_map:= tStringList.Create;
        with l_c_site_map do
        begin
          LoadFromFile(p_site_map_name);
          // display_strings_only(l_c_site_map);

          display_line;
          l_total_zip:= 0;
          for l_index:= 0 to Count- 1 do
          begin
            l_name:= l_c_site_map[l_index];
            if l_name[1]= ' '
              then begin
                  display_log(l_name);
                end
              else display(l_name);
          end;

          display_line;
          display(Format('%-'+ IntToStr(k_name_columns)+ 's ', ['total_zip'])+ IntToStr(l_total_zip));

          Free;
        end; // with l_c_site_map
      end; // display_indented_zip_and_ppt

    procedure c_http_raw_log_pages.display_indented_html(p_site_map_name: String);
      const k_name_columns= 40;
      var l_total_zip: Integer;
          l_total_elapsed_time: Integer;

      procedure display_log(p_map_name: String);
        var l_http_raw_log_page_name: String;
            l_http_raw_log_page: Integer;
            l_map_name: String;
            l_text: String;
            l_elapsed_time: Double;
        begin
          l_map_name:= Trim(p_map_name);

          l_text:= '';
          for l_http_raw_log_page:= 0 to f_http_raw_log_page_count- 1 do
          begin
            l_http_raw_log_page_name:= f_c_http_raw_log_page(l_http_raw_log_page).m_http_raw_log_page_name;

            if f_end_is_equal_to(l_http_raw_log_page_name, '.html')
              then begin
                  if l_map_name= l_http_raw_log_page_name
                    then begin
                        with f_c_http_raw_log_page(l_http_raw_log_page) do
                        begin
                          l_elapsed_time:= m_elapsed_time / (m_http_raw_log_page_count* 1000);
                          l_text:= Format('%2d (%5.1f)', [m_http_raw_log_page_count, l_elapsed_time]);

                          Inc(l_total_zip, m_http_raw_log_page_count);
                          Inc(l_total_elapsed_time, m_elapsed_time);
                          m_used:= True;
                        end;
                      end
                    else
                      if f_name_without_frame_or_top(l_http_raw_log_page_name)= l_map_name
                        then f_c_http_raw_log_page(l_http_raw_log_page).m_used:= True;
                end;
          end;

          if l_text<> ''
            then display(Format('%-'+ IntToStr(k_name_columns)+ 's ', [p_map_name])+ l_text);
        end; // display_log

      var l_c_site_map: tStringList;
          l_index: Integer;
          l_name: String;

      begin // display_indented_html
        l_c_site_map:= tStringList.Create;
        with l_c_site_map do
        begin
          LoadFromFile(p_site_map_name);
          // display_strings_only(l_c_site_map);

          l_total_zip:= 0;
          l_total_elapsed_time:= 0;
          display_line;
          for l_index:= 0 to Count- 1 do
          begin
            l_name:= l_c_site_map[l_index];
            display_log(l_name);
          end;

          display_line;
          display(Format('%-'+ IntToStr(k_name_columns)+ 's ', ['total_html'])
            + Format('%2d (%5d)', [l_total_zip, l_total_elapsed_time]));

          Free;
        end; // with l_c_site_map
      end; // display_indented_html

    procedure c_http_raw_log_pages.display_unused;
      var l_http_raw_log_page: Integer;
      begin
        m_c_http_raw_log_page_list.Sorted:= True;

        for l_http_raw_log_page:= 0 to f_http_raw_log_page_count- 1 do
          with f_c_http_raw_log_page(l_http_raw_log_page) do
            if not m_used
              then display(f_display_http_raw_log_page);
      end; // display_unused

    Destructor c_http_raw_log_pages.Destroy;
      var l_http_raw_log_page: Integer;
      begin
        for l_http_raw_log_page:= 0 to f_http_raw_log_page_count- 1 do
          f_c_http_raw_log_page(l_http_raw_log_page).Free;
        m_c_http_raw_log_page_list.Free;
        Inherited;
      end; // Destroy

    begin // u_c_http_raw_log_page
    end. // u_c_http_raw_log_page

